#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <stdio.h>
#define MAX_NAME             64
#define MAX_CKSUM_ITERATION   4

int PSDES(

  unsigned int *lword,
  unsigned int *irword)

  {
  int index;

  unsigned int ia;
  unsigned int ib;
  unsigned int iswap;
  unsigned int itmph;
  unsigned int itmpl;

  static unsigned int c1[MAX_CKSUM_ITERATION] = {
    (unsigned int)0xcba4e531,
    (unsigned int)0x537158eb,
    (unsigned int)0x145cdc3c,
    (unsigned int)0x0d3fdeb2 };

  static unsigned int c2[MAX_CKSUM_ITERATION] = {
    (unsigned int)0x12be4590,
    (unsigned int)0xab54ce58,
    (unsigned int)0x6954c7a6,
    (unsigned int)0x15a2ca46 };

  itmph = 0;
  itmpl = 0;

  for (index = 0;index < MAX_CKSUM_ITERATION;index++)
    {
    iswap = *irword;

    ia    = iswap ^ c1[index];

    itmpl = ia & 0xffff;
    itmph = ia >> 16;

    ib    = (itmpl * itmpl) + ~(itmph * itmph);
    ia    = (ib >> 16) | ((ib & 0xffff) << 16);

    *irword = (*lword) ^ ((ia ^ c2[index]) + (itmpl * itmph));

    *lword = iswap;
    }  /* END for (index) */

  return(0);
  }  /* END PSDES() */

unsigned short DoCRC(

  unsigned short crc,
  unsigned char  val)

  {
  int          index;

  unsigned int ans;

  ans = (crc ^ val << 8);

  for (index = 0;index < 8;index++)
    {
    if (ans & 0x8000)
      ans = (ans << 1) ^ 4129;
    else
      ans <<= 1;
    }  /* END for (index) */

  return((unsigned short)ans);
  }  /* END DoCRC() */



int GetChecksum(

  char          *Buf,
  int            BufSize,
  char          *Checksum,
  unsigned long  SeedL)

  {
  unsigned int crc;
  unsigned int lword;
  unsigned int rword;

  int          index;

  unsigned int Seed;

  Seed = (unsigned int)SeedL;

  crc = 0;

  for (index = 0;index < BufSize;index++)
    {
    crc = (unsigned int)DoCRC((unsigned short)crc,Buf[index]);
    }

  lword = crc;
  rword = Seed;

  PSDES(&lword,&rword);

  sprintf(Checksum,"%08x%08x",
    lword,
    rword);

  return(0);
  }  /* END GetChecksum() */


MODULE = Maui	PACKAGE = Maui::Msg		


int
checksum(sv,cksum,seed)
	char *		cksum = NO_INIT
    PREINIT:
	STRLEN		len;
    INPUT:
	SV *		sv  
	int		seed
    CODE:
        char *		s = SvPV(sv, len);
        char cs[MAX_NAME];
	cksum = cs;
	RETVAL = GetChecksum(s,len,cksum,seed);        
    OUTPUT:
	cksum

